# Contributing

When contributing to this repository, please first discuss the change you wish to make via issue, email, or any other method with the owners of this repository before making a change.

Please note we have a [code of conduct](https://github.com/Val-istar-Guo/mili/blob/master/.github/CODE_OF_CONDUCT.md), please follow it in all your interactions with the project.


# Issue considerations

* Use templates whenever possible
* Please confirm if there are duplicate problems


# PullRequest considerations

* Update the README.md with details of changes to the interface
* Complete testing of the modified code
* Each commit message must follows the [Conventional Commits Specification](https://conventionalcommits.org/). This will be used for automatic generation of changelog.
* No need to bump the version number, there will be someone responsible for the release.


# Coding style

* Use two Spaces for indenting
* No semicolons
* Use utf8 encoding
